Module Eval
    Public Enum Language
        VB
        CS
        JS
        VJS
    End Enum

    Public Function Eval(ByVal Code As String, ByVal Language As Language) As String
        'Generiamo un nome per l'assembly
        Dim strAssemblyName As String = "b" & Now.Ticks
        'Nome del file della libreria che sar generata
        Dim strFile As String = strAssemblyName & ".dll"
        'Stringa che conterr il codice da compilare
        Dim strCode As String = Nothing
        'Oggetto che permette di compilare, indipendente dal linguaggio
        Dim cd As System.CodeDom.Compiler.CodeDomProvider = Nothing

        'Leggiamo il contesto specifico al linguaggio da un file di testo
        'e vi inseriamo il codice specificato. Creiamo inoltre un'istanza
        'della classe CodeProvider adeguata.
        Select Case Language
            Case Language.CS
                strCode = IO.File.ReadAllText("CS.txt").Replace("{0}", Code)
                cd = New Microsoft.CSharp.CSharpCodeProvider
            Case Language.VB
                strCode = IO.File.ReadAllText("VB.txt").Replace("{0}", Code)
                cd = New Microsoft.VisualBasic.VBCodeProvider()
            Case Language.JS
                strCode = IO.File.ReadAllText("JS.txt").Replace("{0}", Code)
                cd = New Microsoft.JScript.JScriptCodeProvider()
            Case Language.VJS
                strCode = IO.File.ReadAllText("VJS.txt").Replace("{0}", Code)
                cd = New Microsoft.VJSharp.VJSharpCodeProvider()
        End Select

        'Impostiamo i parametri del compilatore,  possibile aggiungere riferimenti personalizzati
        Dim cmpParameters As New System.CodeDom.Compiler.CompilerParameters(New String() {"System.dll"}, strFile)
        'Esegue la compilazione e prende l'output
        Dim cmrResults As System.CodeDom.Compiler.CompilerResults = cd.CompileAssemblyFromSource(cmpParameters, strCode)

        'Se ci sono stati errori generiamo un'eccezione specificando i dettagli
        Dim strResult As String = [String].Empty
        For Each strLine As String In cmrResults.Output
            strResult &= strLine & vbCrLf
        Next
        If Not [String].IsNullOrEmpty(strResult) Then Throw New Exception(strResult)

        'Creiamo l'oggetto AssemblyName che ci servir per identificare il nostro assembly
        Dim asnName As New System.Reflection.AssemblyName(strAssemblyName)
        asnName.CodeBase = strFile
        asnName.Name = strAssemblyName

        'Creiamo un'istanza dell'assembly
        Dim asbInstance As Reflection.Assembly = Reflection.Assembly.Load(asnName)
        'Namespace e nome della classe in cui si trova il codice da eseguire
        Dim strClassName As String = "EvalCode.Execute"
        'Creiamo un'istanza della classe sull'assembly precedentemente richiamato
        Dim objClassInstance As Object = asbInstance.CreateInstance(strClassName)
        'Prendiamo il tipo della classe in questione
        Dim typClass As Type = asbInstance.GetType(strClassName)

        Dim strOutput As String
        'Tramite il tipo richiamiamo il metodo Main (si tratta di una funzione dunque usiamo la binding-flag
        'InvokeMethod) sull'istanza precedentemente creata (objClassInstance). Non passiamo parametri.
        strOutput = CStr(typClass.InvokeMember("Main", _
            Reflection.BindingFlags.InvokeMethod, Nothing, objClassInstance, Nothing))

        'Restituiamo il risultato
        Return strOutput
    End Function


End Module
